@use "colors";
@use "fonts";
@use "layout";
@use "typography";
@use "variables";

.table-of-contents {
    margin-bottom: 2rem;
    font-size: 0.95rem;

    .title {
        font-family: fonts.$title-font;
        font-size: 1.4rem;
        padding-bottom: 1rem;
        overflow: hidden;
        text-overflow: ellipsis;
        @include typography.break-words;
    }

    .list {
        list-style-type: none;
        padding: 0;
        margin: 0;

        li {
            padding-bottom: 0.2em;
        }

        .link {
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
            color: colors.$content-black;
            cursor: pointer;

            &.level-0 {
                margin-left: 0rem;
            }

            &.level-1 {
                margin-left: 1.45rem;
            }

            &.level-2 {
                margin-left: 2rem;
            }

            a {
                vertical-align: top;
                color: inherit;
            }

            a:hover {
                color: colors.$blue !important;
                text-decoration: underline;
                opacity: 1 !important;
            }

            .progress-circle {
                vertical-align: middle;
                padding-bottom: 1px; // HACK: Is there ANY solution to center both text and image vertically?
                padding-right: 0.5rem;

                .base-circle {
                    stroke: colors.$light-gray;
                }

                .progress-path {
                    stroke: colors.$light-gray;
                }

            }
        }
    }

    // Strangely without correction ("- 2rem") it gets outside the screen?
    $available-space: calc((100vw - #{variables.$post-max-width})/2 - 3rem);
    $width: min(calc(#{$available-space} - 5rem), 60%);

    @media screen and (min-width: 1150px) {
        position: sticky;
        margin-left: calc(-1 * #{$available-space});
        top: layout.$page-padding-top;
        margin-bottom: 0;
        height: 0px;
        width: $width;
        max-width: $width;

        @media screen and (max-width: 1400px) {
            font-size: 0.8rem;

            .title {
                font-size: 1.2rem;
            }
        }

        .list {
            list-style-type: none;
            max-height: calc(100vh - #{layout.$page-padding-top} - 41px);
            overflow-y: auto;

            .link {
                a {
                    color: colors.$content-black;
                }

                .progress-circle {
                    .base-circle {
                        stroke: colors.$light-gray;
                    }

                    .progress-path {
                        stroke: colors.$light-gray;
                    }
                }

                &.passing {
                    .base-circle {
                        stroke: colors.$content-black;
                    }
                }

                &.passed {
                    a {
                        color: colors.$content-black;
                    }

                    .progress-circle {
                        .base-circle {
                            stroke: colors.$content-black
                        }
                    }
                }
            }
        }
    }
}